module Main where

import qualified Prelude

data Bool =
   True
 | False

data Star x r =
   Star_refl x
 | Star_R x x x (Star x r) r

data Ascii0 =
   Ascii Bool Bool Bool Bool Bool Bool Bool Bool

data String =
   EmptyString
 | String0 Ascii0 String

star_rect :: (a1 -> a3) -> (a1 -> a1 -> a1 -> (Star a1 a2) -> a3 -> a2 -> a3)
             -> a1 -> a1 -> (Star a1 a2) -> a3
star_rect f f0 _ _ s =
  case s of {
   Star_refl x -> f x;
   Star_R x y z s0 r -> f0 x y z s0 (star_rect f f0 x y s0) r}

star_rec :: (a1 -> a3) -> (a1 -> a1 -> a1 -> (Star a1 a2) -> a3 -> a2 -> a3)
            -> a1 -> a1 -> (Star a1 a2) -> a3
star_rec =
  star_rect

star_trans :: a1 -> a1 -> a1 -> (Star a1 a2) -> (Star a1 a2) -> Star a1 a2
star_trans x y z h h0 =
  star_rec (\_ h1 -> h1) (\_ y0 z0 _ iHstar r h1 -> Star_R x y0 z0
    (iHstar h1) r) y z h0 h

data Star0 x r =
   Star_refl0 x
 | Star_R0 x x x (Star0 x r) r

star_trans0 :: a1 -> a1 -> a1 -> (Star0 a1 a2) -> (Star0 a1 a2) -> Star0 
               a1 a2
star_trans0 =
  star_trans

data Term =
   V String
 | S
 | K
 | App Term Term

data Red =
   S_red Term Term Term
 | K_red Term Term
 | Appl_red Term Term Term Red
 | Appr_red Term Term Term Red
 | Refl Term

type Reds = Star0 Term Red

redt :: Term -> Term -> Term -> (Star0 Term Red) -> (Star0 Term Red) -> Star0
        Term Red
redt =
  star_trans0

appl_reds :: Term -> Term -> Term -> Reds -> Reds
appl_reds m n x h =
  star_rec (\x0 -> Star_refl0 (App x0 x)) (\x0 y z _ iHstar r -> Star_R0 (App
    x0 x) (App y x) (App z x) iHstar (Appl_red y z x r)) m n h

appr_reds :: Term -> Term -> Term -> Reds -> Reds
appr_reds m n x h =
  star_rec (\x0 -> Star_refl0 (App x x0)) (\x0 y z _ iHstar r -> Star_R0 (App
    x x0) (App x y) (App x z) iHstar (Appr_red y z x r)) m n h

app_reds :: Term -> Term -> Term -> Term -> Reds -> Reds -> Reds
app_reds m m' n n' h h0 =
  redt (App m m') (App n m') (App n n') (appl_reds m n m' h)
    (appr_reds m' n' n h0)

s_reds :: Term -> Term -> Term -> Term -> Term -> Term -> Reds -> Reds ->
          Reds -> Reds
s_reds m m' n n' p p' h h0 h1 =
  Star_R0 (App (App (App S m) n) p) (App (App (App S m') n') p') (App (App m'
    p') (App n' p'))
    (app_reds (App (App S m) n) p (App (App S m') n') p'
      (app_reds (App S m) n (App S m') n' (appr_reds m m' S h) h0) h1) (S_red
    m' n' p')

k_reds :: Term -> Term -> Term -> Reds -> Reds
k_reds m m' n h =
  Star_R0 (App (App K m) n) (App (App K m') n) m'
    (appl_reds (App K m) (App K m') n (appr_reds m m' K h)) (K_red m' n)

data Star1 x r =
   Star_refl1 x
 | Star_R1 x x x (Star1 x r) r

data Term0 =
   V0 String
 | S0
 | K0
 | App0 Term0 Term0

i :: Term
i =
  App (App S0 K0) K0

identity_combinator :: Term -> Reds
identity_combinator x =
  Star_R1 (App (App (App S0 K0) K0) x) (App (App K0 x) (App K0 x)) x
    (s_reds K0 K0 K0 K0 x x (Star_refl1 K0) (Star_refl1 K0) (Star_refl1 x))
    (K_red x (App K0 x))

duplicate_combinator :: Term -> Term -> Reds
duplicate_combinator f x =
  Star_R1 (App (App (App (App S0 S0) (App K0 i)) f) x) (App (App f x) (App
    (App K0 x) (App K0 x))) (App (App f x) x) (Star_R1 (App (App (App (App S0
    S0) (App K0 i)) f) x) (App (App f x) (App (App (App S0 K0) K0) x)) (App
    (App f x) (App (App K0 x) (App K0 x))) (Star_R1 (App (App (App (App S0
    S0) (App K0 (App (App S0 K0) K0))) f) x) (App (App f x) (App i x)) (App
    (App f x) (App (App (App S0 K0) K0) x)) (Star_R1 (App (App (App (App S0
    S0) (App K0 (App (App S0 K0) K0))) f) x) (App (App f x) (App (App (App K0
    i) f) x)) (App (App f x) (App i x)) (Star_R1 (App (App (App (App S0 S0)
    (App K0 (App (App S0 K0) K0))) f) x) (App (App (App S0 f) (App (App K0 i)
    f)) x) (App (App f x) (App (App (App K0 i) f) x))
    (appl_reds (App (App (App S0 S0) (App K0 (App (App S0 K0) K0))) f) (App
      (App S0 f) (App (App K0 i) f)) x
      (s_reds S0 S0 (App K0 (App (App S0 K0) K0)) (App K0 i) f f (Star_refl1
        S0) (Star_refl1 (App K0 i)) (Star_refl1 f))) (S_red f (App (App K0 i)
    f) x)) (Appr_red (App (App (App K0 i) f) x) (App i x) (App f x) (Appl_red
    (App (App K0 i) f) i x (K_red i f)))) (Appr_red (App i x) (App (App (App
    S0 K0) K0) x) (App f x) (Refl (App (App (App S0 K0) K0) x)))) (Appr_red
    (App (App (App S0 K0) K0) x) (App (App K0 x) (App K0 x)) (App f x) (S_red
    K0 K0 x))) (Appr_red (App (App K0 x) (App K0 x)) x (App f x) (K_red x
    (App K0 x)))

compose_combinator :: Term -> Term -> Term -> Reds
compose_combinator f g x =
  Star_R1 (App (App (App (App (App S0 (App K0 S0)) K0) f) g) x) (App (App
    (App K0 f) x) (App g x)) (App f (App g x)) (Star_R1 (App (App (App (App
    (App S0 (App K0 S0)) K0) f) g) x) (App (App (App S0 (App K0 f)) g) x)
    (App (App (App K0 f) x) (App g x)) (Star_R1 (App (App (App (App (App S0
    (App K0 S0)) K0) f) g) x) (App (App (App (App (App K0 S0) f) (App K0 f))
    g) x) (App (App (App S0 (App K0 f)) g) x)
    (appl_reds (App (App (App (App S0 (App K0 S0)) K0) f) g) (App (App (App
      (App K0 S0) f) (App K0 f)) g) x
      (appl_reds (App (App (App S0 (App K0 S0)) K0) f) (App (App (App K0 S0)
        f) (App K0 f)) g
        (s_reds (App K0 S0) (App K0 S0) K0 K0 f f (Star_refl1 (App K0 S0))
          (Star_refl1 K0) (Star_refl1 f)))) (Appl_red (App (App (App (App K0
    S0) f) (App K0 f)) g) (App (App S0 (App K0 f)) g) x (Appl_red (App (App
    (App K0 S0) f) (App K0 f)) (App S0 (App K0 f)) g (Appl_red (App (App K0
    S0) f) S0 (App K0 f) (K_red S0 f))))) (S_red (App K0 f) g x)) (Appl_red
    (App (App K0 f) x) f (App g x) (K_red f x))

permute_combinator :: Term -> Term -> Term -> Reds
permute_combinator f x y =
  Star_R1 (App (App (App (App (App S0 (App (App (App (App S0 (App K0 S0)) K0)
    (App (App S0 (App K0 S0)) K0)) S0)) (App K0 K0)) f) x) y) (App (App f y)
    (App (App K0 x) y)) (App (App f y) x) (Star_R1 (App (App (App (App (App
    S0 (App (App (App (App S0 (App K0 S0)) K0) (App (App S0 (App K0 S0)) K0))
    S0)) (App K0 K0)) f) x) y) (App (App f y) (App (App (App (App K0 K0) f)
    x) y)) (App (App f y) (App (App K0 x) y)) (Star_R1 (App (App (App (App
    (App S0 (App (App (App (App S0 (App K0 S0)) K0) (App (App S0 (App K0 S0))
    K0)) S0)) (App K0 K0)) f) x) y) (App (App (App S0 f) (App (App (App K0
    K0) f) x)) y) (App (App f y) (App (App (App (App K0 K0) f) x) y))
    (Star_R1 (App (App (App (App (App S0 (App (App (App (App S0 (App K0 S0))
    K0) (App (App S0 (App K0 S0)) K0)) S0)) (App K0 K0)) f) x) y) (App (App
    (App (App K0 (App S0 f)) x) (App (App (App K0 K0) f) x)) y) (App (App
    (App S0 f) (App (App (App K0 K0) f) x)) y) (Star_R1 (App (App (App (App
    (App S0 (App (App (App (App S0 (App K0 S0)) K0) (App (App S0 (App K0 S0))
    K0)) S0)) (App K0 K0)) f) x) y) (App (App (App (App S0 (App K0 (App S0
    f))) (App (App K0 K0) f)) x) y) (App (App (App (App K0 (App S0 f)) x)
    (App (App (App K0 K0) f) x)) y) (Star_R1 (App (App (App (App (App S0 (App
    (App (App (App S0 (App K0 S0)) K0) (App (App S0 (App K0 S0)) K0)) S0))
    (App K0 K0)) f) x) y) (App (App (App (App (App (App K0 S0) (App S0 f))
    (App K0 (App S0 f))) (App (App K0 K0) f)) x) y) (App (App (App (App S0
    (App K0 (App S0 f))) (App (App K0 K0) f)) x) y) (Star_R1 (App (App (App
    (App (App S0 (App (App (App (App S0 (App K0 S0)) K0) (App (App S0 (App K0
    S0)) K0)) S0)) (App K0 K0)) f) x) y) (App (App (App (App (App (App S0
    (App K0 S0)) K0) (App S0 f)) (App (App K0 K0) f)) x) y) (App (App (App
    (App (App (App K0 S0) (App S0 f)) (App K0 (App S0 f))) (App (App K0 K0)
    f)) x) y) (Star_R1 (App (App (App (App (App S0 (App (App (App (App S0
    (App K0 S0)) K0) (App (App S0 (App K0 S0)) K0)) S0)) (App K0 K0)) f) x)
    y) (App (App (App (App (App (App K0 (App (App S0 (App K0 S0)) K0)) f)
    (App S0 f)) (App (App K0 K0) f)) x) y) (App (App (App (App (App (App S0
    (App K0 S0)) K0) (App S0 f)) (App (App K0 K0) f)) x) y) (Star_R1 (App
    (App (App (App (App S0 (App (App (App (App S0 (App K0 S0)) K0) (App (App
    S0 (App K0 S0)) K0)) S0)) (App K0 K0)) f) x) y) (App (App (App (App (App
    (App S0 (App K0 (App (App S0 (App K0 S0)) K0))) S0) f) (App (App K0 K0)
    f)) x) y) (App (App (App (App (App (App K0 (App (App S0 (App K0 S0)) K0))
    f) (App S0 f)) (App (App K0 K0) f)) x) y) (Star_R1 (App (App (App (App
    (App S0 (App (App (App (App S0 (App K0 S0)) K0) (App (App S0 (App K0 S0))
    K0)) S0)) (App K0 K0)) f) x) y) (App (App (App (App (App (App (App (App
    K0 S0) (App (App S0 (App K0 S0)) K0)) (App K0 (App (App S0 (App K0 S0))
    K0))) S0) f) (App (App K0 K0) f)) x) y) (App (App (App (App (App (App S0
    (App K0 (App (App S0 (App K0 S0)) K0))) S0) f) (App (App K0 K0) f)) x) y)
    (Star_R1 (App (App (App (App (App S0 (App (App (App (App S0 (App K0 S0))
    K0) (App (App S0 (App K0 S0)) K0)) S0)) (App K0 K0)) f) x) y) (App (App
    (App (App (App (App (App (App S0 (App K0 S0)) K0) (App (App S0 (App K0
    S0)) K0)) S0) f) (App (App K0 K0) f)) x) y) (App (App (App (App (App (App
    (App (App K0 S0) (App (App S0 (App K0 S0)) K0)) (App K0 (App (App S0 (App
    K0 S0)) K0))) S0) f) (App (App K0 K0) f)) x) y)
    (appl_reds (App (App (App (App S0 (App (App (App (App S0 (App K0 S0)) K0)
      (App (App S0 (App K0 S0)) K0)) S0)) (App K0 K0)) f) x) (App (App (App
      (App (App (App (App S0 (App K0 S0)) K0) (App (App S0 (App K0 S0)) K0))
      S0) f) (App (App K0 K0) f)) x) y
      (appl_reds (App (App (App S0 (App (App (App (App S0 (App K0 S0)) K0)
        (App (App S0 (App K0 S0)) K0)) S0)) (App K0 K0)) f) (App (App (App
        (App (App (App S0 (App K0 S0)) K0) (App (App S0 (App K0 S0)) K0)) S0)
        f) (App (App K0 K0) f)) x
        (s_reds (App (App (App (App S0 (App K0 S0)) K0) (App (App S0 (App K0
          S0)) K0)) S0) (App (App (App (App S0 (App K0 S0)) K0) (App (App S0
          (App K0 S0)) K0)) S0) (App K0 K0) (App K0 K0) f f (Star_refl1 (App
          (App (App (App S0 (App K0 S0)) K0) (App (App S0 (App K0 S0)) K0))
          S0)) (Star_refl1 (App K0 K0)) (Star_refl1 f)))) (Appl_red (App (App
    (App (App (App (App (App S0 (App K0 S0)) K0) (App (App S0 (App K0 S0))
    K0)) S0) f) (App (App K0 K0) f)) x) (App (App (App (App (App (App (App K0
    S0) (App (App S0 (App K0 S0)) K0)) (App K0 (App (App S0 (App K0 S0))
    K0))) S0) f) (App (App K0 K0) f)) x) y (Appl_red (App (App (App (App (App
    (App S0 (App K0 S0)) K0) (App (App S0 (App K0 S0)) K0)) S0) f) (App (App
    K0 K0) f)) (App (App (App (App (App (App K0 S0) (App (App S0 (App K0 S0))
    K0)) (App K0 (App (App S0 (App K0 S0)) K0))) S0) f) (App (App K0 K0) f))
    x (Appl_red (App (App (App (App (App S0 (App K0 S0)) K0) (App (App S0
    (App K0 S0)) K0)) S0) f) (App (App (App (App (App K0 S0) (App (App S0
    (App K0 S0)) K0)) (App K0 (App (App S0 (App K0 S0)) K0))) S0) f) (App
    (App K0 K0) f) (Appl_red (App (App (App (App S0 (App K0 S0)) K0) (App
    (App S0 (App K0 S0)) K0)) S0) (App (App (App (App K0 S0) (App (App S0
    (App K0 S0)) K0)) (App K0 (App (App S0 (App K0 S0)) K0))) S0) f (Appl_red
    (App (App (App S0 (App K0 S0)) K0) (App (App S0 (App K0 S0)) K0)) (App
    (App (App K0 S0) (App (App S0 (App K0 S0)) K0)) (App K0 (App (App S0 (App
    K0 S0)) K0))) S0 (S_red (App K0 S0) K0 (App (App S0 (App K0 S0))
    K0)))))))) (Appl_red (App (App (App (App (App (App (App K0 S0) (App (App
    S0 (App K0 S0)) K0)) (App K0 (App (App S0 (App K0 S0)) K0))) S0) f) (App
    (App K0 K0) f)) x) (App (App (App (App (App S0 (App K0 (App (App S0 (App
    K0 S0)) K0))) S0) f) (App (App K0 K0) f)) x) y (Appl_red (App (App (App
    (App (App (App K0 S0) (App (App S0 (App K0 S0)) K0)) (App K0 (App (App S0
    (App K0 S0)) K0))) S0) f) (App (App K0 K0) f)) (App (App (App (App S0
    (App K0 (App (App S0 (App K0 S0)) K0))) S0) f) (App (App K0 K0) f)) x
    (Appl_red (App (App (App (App (App K0 S0) (App (App S0 (App K0 S0)) K0))
    (App K0 (App (App S0 (App K0 S0)) K0))) S0) f) (App (App (App S0 (App K0
    (App (App S0 (App K0 S0)) K0))) S0) f) (App (App K0 K0) f) (Appl_red (App
    (App (App (App K0 S0) (App (App S0 (App K0 S0)) K0)) (App K0 (App (App S0
    (App K0 S0)) K0))) S0) (App (App S0 (App K0 (App (App S0 (App K0 S0))
    K0))) S0) f (Appl_red (App (App (App K0 S0) (App (App S0 (App K0 S0))
    K0)) (App K0 (App (App S0 (App K0 S0)) K0))) (App S0 (App K0 (App (App S0
    (App K0 S0)) K0))) S0 (Appl_red (App (App K0 S0) (App (App S0 (App K0
    S0)) K0)) S0 (App K0 (App (App S0 (App K0 S0)) K0)) (K_red S0 (App (App
    S0 (App K0 S0)) K0))))))))) (Appl_red (App (App (App (App (App S0 (App K0
    (App (App S0 (App K0 S0)) K0))) S0) f) (App (App K0 K0) f)) x) (App (App
    (App (App (App K0 (App (App S0 (App K0 S0)) K0)) f) (App S0 f)) (App (App
    K0 K0) f)) x) y (Appl_red (App (App (App (App S0 (App K0 (App (App S0
    (App K0 S0)) K0))) S0) f) (App (App K0 K0) f)) (App (App (App (App K0
    (App (App S0 (App K0 S0)) K0)) f) (App S0 f)) (App (App K0 K0) f)) x
    (Appl_red (App (App (App S0 (App K0 (App (App S0 (App K0 S0)) K0))) S0)
    f) (App (App (App K0 (App (App S0 (App K0 S0)) K0)) f) (App S0 f)) (App
    (App K0 K0) f) (S_red (App K0 (App (App S0 (App K0 S0)) K0)) S0 f)))))
    (Appl_red (App (App (App (App (App K0 (App (App S0 (App K0 S0)) K0)) f)
    (App S0 f)) (App (App K0 K0) f)) x) (App (App (App (App (App S0 (App K0
    S0)) K0) (App S0 f)) (App (App K0 K0) f)) x) y (Appl_red (App (App (App
    (App K0 (App (App S0 (App K0 S0)) K0)) f) (App S0 f)) (App (App K0 K0)
    f)) (App (App (App (App S0 (App K0 S0)) K0) (App S0 f)) (App (App K0 K0)
    f)) x (Appl_red (App (App (App K0 (App (App S0 (App K0 S0)) K0)) f) (App
    S0 f)) (App (App (App S0 (App K0 S0)) K0) (App S0 f)) (App (App K0 K0) f)
    (Appl_red (App (App K0 (App (App S0 (App K0 S0)) K0)) f) (App (App S0
    (App K0 S0)) K0) (App S0 f) (K_red (App (App S0 (App K0 S0)) K0) f))))))
    (Appl_red (App (App (App (App (App S0 (App K0 S0)) K0) (App S0 f)) (App
    (App K0 K0) f)) x) (App (App (App (App (App K0 S0) (App S0 f)) (App K0
    (App S0 f))) (App (App K0 K0) f)) x) y (Appl_red (App (App (App (App S0
    (App K0 S0)) K0) (App S0 f)) (App (App K0 K0) f)) (App (App (App (App K0
    S0) (App S0 f)) (App K0 (App S0 f))) (App (App K0 K0) f)) x (Appl_red
    (App (App (App S0 (App K0 S0)) K0) (App S0 f)) (App (App (App K0 S0) (App
    S0 f)) (App K0 (App S0 f))) (App (App K0 K0) f) (S_red (App K0 S0) K0
    (App S0 f)))))) (Appl_red (App (App (App (App (App K0 S0) (App S0 f))
    (App K0 (App S0 f))) (App (App K0 K0) f)) x) (App (App (App S0 (App K0
    (App S0 f))) (App (App K0 K0) f)) x) y (Appl_red (App (App (App (App K0
    S0) (App S0 f)) (App K0 (App S0 f))) (App (App K0 K0) f)) (App (App S0
    (App K0 (App S0 f))) (App (App K0 K0) f)) x (Appl_red (App (App (App K0
    S0) (App S0 f)) (App K0 (App S0 f))) (App S0 (App K0 (App S0 f))) (App
    (App K0 K0) f) (Appl_red (App (App K0 S0) (App S0 f)) S0 (App K0 (App S0
    f)) (K_red S0 (App S0 f))))))) (Appl_red (App (App (App S0 (App K0 (App
    S0 f))) (App (App K0 K0) f)) x) (App (App (App K0 (App S0 f)) x) (App
    (App (App K0 K0) f) x)) y (S_red (App K0 (App S0 f)) (App (App K0 K0) f)
    x))) (Appl_red (App (App (App K0 (App S0 f)) x) (App (App (App K0 K0) f)
    x)) (App (App S0 f) (App (App (App K0 K0) f) x)) y (Appl_red (App (App K0
    (App S0 f)) x) (App S0 f) (App (App (App K0 K0) f) x) (K_red (App S0 f)
    x)))) (S_red f (App (App (App K0 K0) f) x) y)) (Appr_red (App (App (App
    (App K0 K0) f) x) y) (App (App K0 x) y) (App f y) (Appl_red (App (App
    (App K0 K0) f) x) (App K0 x) y (Appl_red (App (App K0 K0) f) K0 x (K_red
    K0 f))))) (Appr_red (App (App K0 x) y) x (App f y) (K_red x y))
