Require Import General_relations.
Require Import SK.
Require Import SK_wreduction.

Include GRels.
Include CL.

Set Implicit Arguments.

Definition I := S @ K @ K.
Definition W := S @ S @ (K @ I).
Definition B := S @ (K @ S) @ K.
Definition C := S @ (B @ B @ S) @ (K @ K).

Lemma identity_combinator : forall x, reds (I @ x) x.
Proof.
  intros.
  unfold I.
  apply (star_R _ _ _ (K @ x @ (K @ x)) _).
  apply S_reds.
  apply star_refl.
  apply star_refl.
  apply star_refl.
  apply k_red.
Qed.

Lemma duplicate_combinator : forall f x, reds (W @ f @ x) (f @ x @ x).
Proof.
  intros.
  unfold W.
  apply (star_R _ _ _ (f @ x @ (K @ x @ (K @ x))) _).
  apply (star_R _ _ _ (f @ x @ (S @ K @ K @ x)) _).
  unfold I.
  apply (star_R _ _ _ (f @ x @ (I @ x)) _).
  apply (star_R _ _ _ (f @ x @ ((K @ I @ f) @ x)) _).
  apply (star_R _ _ _ (S @ f @ (K @ I @ f) @ x) _).
  apply appl_reds.
  apply S_reds.
  apply star_refl.
  apply star_refl.
  apply star_refl.
  apply s_red.
  apply appr_red.
  apply appl_red.
  apply k_red.
  apply appr_red.
  unfold I.
  apply refl.
  apply appr_red.
  apply s_red.
  apply appr_red.
  apply k_red.
Qed.

Lemma compose_combinator : forall f g x, reds (B @ f @ g @ x) (f @ (g @ x)).
Proof.
  intros. unfold B.
  apply (star_R _ _ _ (K @ f @ x @ (g @ x)) _).
  apply (star_R _ _ _ (S @ (K @ f) @ g @ x) _).
  apply (star_R _ _ _ (K @ S @ f @ (K @ f) @ g @ x) _).
  apply appl_reds.
  apply appl_reds.
  apply S_reds.
  apply star_refl.
  apply star_refl.
  apply star_refl.
  apply appl_red.
  apply appl_red.
  apply appl_red.
  apply k_red.
  apply s_red.
  apply appl_red.
  apply k_red.
Qed.

Lemma permute_combinator : forall f x y, reds (C @ f @ x @ y) (f @ y @ x).
Proof.
  intros.
  unfold C.
  unfold B.
  apply
    (star_R _ _ _ (f @ y @ (K @ x @ y)) _).
  apply
    (star_R _ _ _ (f @ y @ (K @ K @ f @ x @ y)) _).
  apply
    (star_R _ _ _ (S @ f @ (K @ K @ f @ x) @ y) _).
  apply
    (star_R _ _ _ (K @ (S @ f) @ x @ (K @ K @ f @ x) @ y) _).
  apply
    (star_R _ _ _ (S @ (K @ (S @ f)) @ (K @ K @ f) @ x @ y) _).
  apply
    (star_R _ _ _ (K @ S @ (S @ f) @ (K @ (S @ f)) @ (K @ K @ f)
                        @ x @ y) _).
  apply
    (star_R _ _ _ (S @ (K @ S) @ K @ (S @ f) @ (K @ K @ f)
                        @ x @ y) _).
  apply
    (star_R _ _ _ (K @ (S @ (K @ S) @ K) @ f @ (S @ f)
                        @ (K @ K @ f) @ x @ y) _).
  apply
    (star_R _ _ _ (S @ (K @ (S @ (K @ S) @ K)) @ S @ f
                        @ (K @ K @ f) @ x @ y) _).
  apply
    (star_R _ _ _ (K @ S @ (S @ (K @ S) @ K)
                        @ (K @ (S @ (K @ S) @ K)) @ S @ f
                        @ (K @ K @ f) @ x @ y) _).
  apply
    (star_R _ _ _ (S @ (K @ S) @ K @ (S @ (K @ S) @ K)
                        @ S @ f @ (K @ K @ f) @ x @ y) _).
  apply appl_reds.
  apply appl_reds.
  apply S_reds.
  apply star_refl.
  apply star_refl.
  apply star_refl.
  apply appl_red.
  apply appl_red.
  apply appl_red.
  apply appl_red.
  apply appl_red.
  apply s_red.
  apply appl_red.
  apply appl_red.
  apply appl_red.
  apply appl_red.
  apply appl_red.
  apply appl_red.
  apply k_red.
  apply appl_red.
  apply appl_red.
  apply appl_red.
  apply s_red.
  apply appl_red.
  apply appl_red.
  apply appl_red.
  apply appl_red.
  apply k_red.
  apply appl_red.
  apply appl_red.
  apply appl_red.
  apply s_red.
  apply appl_red.
  apply appl_red.
  apply appl_red.
  apply appl_red.
  apply k_red.
  apply appl_red.
  apply s_red.
  apply appl_red.
  apply appl_red.
  apply k_red.
  apply s_red.
  apply appr_red.
  apply appl_red.
  apply appl_red.
  apply k_red.
  apply appr_red.
  apply k_red.
Qed.